//Visualization 1: link all the data that was collected on the same date at different times
void drawVersion1(boolean tEffect, boolean hEffect) {
  float z1, z2,  x1,  y1, y2;
  
  for(int t = 0; t<50; t++){
    for(int i = 0; i<totalDate; i++){
      boolean hover = false; 
      x1 = i*adjustX; //compute the x-axis for each date
      float p_x = screenX(x1, 0, 0);  //compute the screenX of this point
    
      for(int j = 1; j<24-1; j++){  // For each time(hour)
        // If select temperature data
        if (tEffect){if(hoverEffect){if(sq(mouseX-p_x)<50){// If the distance of screenX and mouseX is small enough
          hover = true;// trigger hover effect
          stroke(int(abs(14-j)*100/12),240-int(abs(totalDate/2-i)*6),200,180); // set hover color
      }
        else{stroke(int(abs(14-j)*100/12),240-int(abs(totalDate/2-i)*6),50,60);}  }
        // If the hoverEffect is off
        else{stroke(int(abs(14-j)*100/12),240-int(abs(totalDate/2-i)*6),200,180);}}
        // If select humidity data
        if (hEffect){if(hoverEffect){if(sq(mouseX-p_x)<50){// If the distance of screenX and mouseX is small enough
          hover = true;
          stroke(int(60+abs(14-j)*140/12),240-int(abs(totalDate/2-i)*6),200,180);}
        else{stroke(int(60+abs(14-j)*140/12),240-int(abs(totalDate/2-i)*6),50,60);}  }
        else{stroke(int(60+abs(14-j)*140/12),240-int(abs(totalDate/2-i)*6),200,180);}}
  
        strokeWeight(2);
        y1 = j * adjustY;// compute the time for y-axis
        y2 = (j+1) * adjustY; 
        z1 = cVolume[t][i][j]; //compute the corresponding z value
        z2 = cVolume[t][i][j+1];

        if((z1!=float(0))&(z2!=float(0))){// if this timestamp has data record
           if(logEffect){// If the logEffect is on (by default)
          z1 = log(1+cVolume[t][i][j])/log(logBase); // Compute the preocessed z value
          z2 = log(1+cVolume[t][i][j+1])/log(logBase);
        }       
        
        line(x1, y1, adjustZ*z1+t*spaceZ, x1, y2, adjustZ*z2+t*spaceZ);}// link the data
      }
    
    if(hover){// set the hover effect of showing text
        stroke(100);
        strokeWeight(1);
        textFont(hoverText);
        pushMatrix();
        translate(i*adjustX, 0,400+(i%5)*20);
        rotateX(PI/2);
        rotateZ(PI);
        scale(0.2);
        textMode(SHAPE);
        textAlign(LEFT, CENTER);   
        text(dates[i], 40, 0, 0);
        popMatrix();
        strokeWeight(2);}
  }
  }
}

//Visualization 2: link all the data that was collected at the same time on different dates
void drawVersion2(boolean tEffect, boolean hEffect) {
  float z1, z2,  y1,  x1, x2;
  strokeWeight(2);
  
  for(int t = 0; t<50; t++){// for each index
    for(int j = 0; j<24; j++){// for each hour
      boolean hover = false;
      y1 = j*adjustY; //compute the y-axis for each time(hour)
      float p_x = screenX(0, j*adjustY, 0); //compute the screenX of this time
      for(int i = 0; i<totalDate-1; i++){// for each date
        // If select temperature data
        if (tEffect){if(hoverEffect){if(sq(mouseX-p_x)<50){// If the distance of screenX and mouseX is small enough
          hover = true;// set hovereffect
          stroke(int(abs(14-j)*100/12),240-int(abs(totalDate/2-i)*6),200,180);}
          else{stroke(int(abs(14-j)*100/12),240-int(abs(totalDate/2-i)*6),50,60);}  }
          else{stroke(int(abs(14-j)*100/12),240-int(abs(totalDate/2-i)*6),200,180);}}
        // If select humidity data
        if (hEffect){if(hoverEffect){if(sq(mouseX-p_x)<50){
          hover = true;
          stroke(int(60+abs(14-j)*140/12),240-int(abs(totalDate/2-i)*6),200,180);}
          else{stroke(int(60+abs(14-j)*140/12),240-int(abs(totalDate/2-i)*6),50,60);}  }
          else{stroke(int(60+abs(14-j)*140/12),240-int(abs(totalDate/2-i)*6),200,180);}}

        x1 = i * adjustX; // compute the date
        x2 = (i+1) * adjustX; 
        
        z1 = cVolume[t][i][j]; // compute the z-value of the timestamp
        z2 = cVolume[t][i+1][j];
          
       if((z1!=float(0))&(z2!=float(0))){// if this timestamp has data record
          if(logEffect){// If the logEffect is on (by default)
          z1 = log(1+cVolume[t][i][j])/log(logBase);
          z2 = log(1+cVolume[t][i+1][j])/log(logBase);

        }
        line(x1, y1, adjustZ*z1+t*spaceZ, x2, y1, adjustZ*z2+t*spaceZ);}// link the data
 
    }
        if(hover){// set the hover effect
        stroke(100);
        strokeWeight(1);
        textFont(hoverText);
        pushMatrix();
        translate(0, j*adjustY,400+(j%4)*50);
        rotateY(PI/2);
        rotateX(PI);
        rotateZ(-3*PI/4);
        scale(0.2);
        textMode(SHAPE);
        textAlign(LEFT, CENTER);
        text(str(j)+":00", 40, 0, 0);
        popMatrix();
        strokeWeight(2);}
  }
}
}

//Visualization 3: create a surface based on all the data of the same sample
void drawVersion3(boolean tEffect, boolean hEffect) {
  float z1, z2,z3,z4,  y1,y2,  x1, x2;
  strokeWeight(0.5);
  
  for(int t = 0; t<50; t++){// for each sample(index)
    float p_y = screenY(0, 0, t*spaceZ); //compute the screenY of this sample
    boolean hover = false;
    for(int j = 0; j<24-1; j++){// for each time
      beginShape(TRIANGLE_STRIP);//connect the vertex for a mesh
      for(int i = 0; i<totalDate-1; i++){// for each date
        if (hEffect){if(hoverEffect){if(sq(mouseY-p_y)<50){
          hover = true;
          fill(t*2.5+120,150,150,140);
          stroke(150,120);}
        else{
          fill(t*2.5+120,150,50,40);
          stroke(150,50);}}
        else{
          fill(t*2.5+120,150,100,100);
          stroke(150,100);} }
        if (tEffect){if(hoverEffect){if(sq(mouseY-p_y)<50){
          hover = true;
          fill(t*3+20,150,150,140);
          stroke(150,120);}
     
        else{
          fill(t*3+20,150,50,40);
          stroke(150,50);}}
        else{
          fill(t*3+20,150,100,100);
          stroke(150,100);} }  
      
        x1 = i * adjustX; // compute the date-axis
        x2 = (i+1) * adjustX;
        y1 = j * adjustY;// compute the time-axis
        y2 = (j+1) * adjustY;
        z1 = cVolume[t][i][j];// compute the z-value
        z2 = cVolume[t][i+1][j];
        z3 = cVolume[t][i+1][j+1];
        z4 = cVolume[t][i][j+1];
        if((z1!=float(0))&(z2!=float(0))&(z3!=float(0))&(z4!=float(0))){// if the timestamp contain records
          if(logEffect){
          z1 = log(1+cVolume[t][i][j])/log(logBase);
          z2 = log(1+cVolume[t][i+1][j])/log(logBase);
          z3 = log(1+cVolume[t][i+1][j+1])/log(logBase);
          z4 = log(1+cVolume[t][i][j+1])/log(logBase);}
          
          
          vertex(x1, y1, adjustZ*z1+t*spaceZ);
          vertex(x1, y2, adjustZ*z4+t*spaceZ);
          //vertex(x2, y2, adjustZ*z3+t*spaceZ);
          //vertex(x2, y1, adjustZ*z2+t*spaceZ);
          }

    }
     endShape();
  }
      if(hover){//set hover effect
        fill(255);
        stroke(100);
        strokeWeight(1);
        textFont(hoverText);
        pushMatrix();
        translate(0, 0,t*spaceZ);
        rotateY(PI/2);
        rotateX(PI);
        rotateZ(-3*PI/4);
        scale(0.2);
        textMode(SHAPE);
        textAlign(LEFT, CENTER);
        
        text("Index"+str(t), -40, 0, 0);
        popMatrix();
        strokeWeight(0.5);}
}
}

// Draw the axises and the box
void drawPlatform() {
  noFill (); 
  stroke(80);//partially transparent at 80 as 255 is full opaque
  textFont(axisText);
  textAlign(CENTER);
  pushMatrix();
  translate(X/2, Y/2, Z/2);
  box(X, Y, Z); 
  popMatrix();
  int stickLength = 10;
  //draw Date-axis
  String currentDate = "7/16/21";
  for (int i = 0; i <= totalDate - 1; i++) {
    line(i*adjustX+5, 0-stickLength, i*adjustX+5,0);
    fill(255);
    String date = nextDate(currentDate);
    dates[i] = date;
    currentDate = date;
    pushMatrix();
    translate(i*adjustX+10,-50,0);
    rotateX(PI/2);
    rotateZ(3*PI/4);
    text(date,  0,0);
    popMatrix();
  }
  //draw time-axis
  fill(255);
  for (int j = 0; j < 24; j++) {
    line(0, j*adjustY, -stickLength,j*adjustY);
    pushMatrix();
    translate(-2*stickLength, j* adjustY,0);
    rotateY(PI/2);
    rotateX(PI);
    rotateZ(-3*PI/4);
    textAlign(CENTER);
    text(str(j)+":00", 0, 0);
    popMatrix();
  }
  // draw axis label
  pushMatrix();
  translate(X/2, Y+50, 0);
  rotateX(-PI/2);
  text("Date", 0,0,0);
  popMatrix();
  pushMatrix();
  translate(X+50, Y/2, 0);
  rotateZ(-PI/2);
  rotateX(-PI/2);
  text("Time", 0,0,0);
  popMatrix();  
}
