Textlabel manualLabel;
Textlabel modeLabel;
Textlabel controlLabel;
int infoX;
int infoY;
color guiBgColor;
int tc1 = #FFFFFF;
// set the title
void title(){
  hint(DISABLE_DEPTH_TEST);
  cam.beginHUD();
  
  stroke(150);
  fill(255);
  PFont fHead = createFont("Arial", 30);
  textFont(fHead);
  textAlign(LEFT, CENTER);
  text("Visualization For Field Workers",20,40,0);
  
  cam.endHUD();
  hint(ENABLE_DEPTH_TEST);

}
// set the GUI 
void setupGUI(){
  guiBgColor = color(0,0,40, 200);//background color
  controlP5 = new ControlP5(this);
 
  l = controlP5.addGroup("", 0, 0, 800);//add a controlP5 group
  l.activateEvent(true);
  l.hideBar();
  l.setBackgroundColor(guiBgColor);//set the background color
  l.setBackgroundHeight(100);

  infoX = 20;
  infoY = 10;
  // set the manual title
  manualLabel = controlP5.addTextlabel("manual", "Manual", infoX, infoY); 
  manualLabel.setColorValue(tc1);
  manualLabel.setGroup(l);

  // set the mode label
  infoX = 20;
  infoY = 30;
  modeLabel = controlP5.addTextlabel("visualizationDisplayModesAll", "Set Visualization Display Mode", infoX, infoY); 
  modeLabel.setColorValue(tc1);
  modeLabel.setGroup(l);
  infoY+=15;
  
  modeLabel  = controlP5.addTextlabel("visualizationDisplayModes1", "1: Visualization 1", infoX, infoY); 
  modeLabel.setColorValue(tc1);
  modeLabel.setGroup(l);
  infoY+=15;
  
  modeLabel  = controlP5.addTextlabel("visualizationDisplayModes2", "2: Visualization 2", infoX, infoY); 
  modeLabel.setColorValue(tc1);
  modeLabel.setGroup(l);
  infoY+=15;  

  modeLabel  = controlP5.addTextlabel("visualizationDisplayModes3", "3: Visualization 3", infoX, infoY); 
  modeLabel.setColorValue(tc1);
  modeLabel.setGroup(l);
  infoY = 30+15;
  infoX  +=150;
  
  modeLabel  = controlP5.addTextlabel("visualizationDisplayModesT", "T: Temperature Data", infoX, infoY); 
  modeLabel.setColorValue(tc1);
  modeLabel.setGroup(l);
  infoY+=15;
  
  modeLabel  = controlP5.addTextlabel("visualizationDisplayModesH", "H: Humidity Data", infoX, infoY); 
  modeLabel.setColorValue(tc1);
  modeLabel.setGroup(l);
  
  infoY=35;
  infoX+=250;
  
  // set the control label
  controlLabel  = controlP5.addTextlabel("contorlDisplay", "Control Visualization Display", infoX, infoY); 
  controlLabel.setColorValue(tc1);
  controlLabel.setGroup(l);
  infoY+=15;  
  
  controlLabel  = controlP5.addTextlabel("contorlDisplayHover", "R: Hovering Effect", infoX, infoY); 
  controlLabel.setColorValue(tc1);
  controlLabel.setGroup(l);
  infoY+=15;    

  controlLabel  = controlP5.addTextlabel("contorlDisplayTimeAxis", "W&S: Time-Axis Spacing", infoX, infoY); 
  controlLabel.setColorValue(tc1);
  controlLabel.setGroup(l);
  infoY+=15;  
  
  controlLabel  = controlP5.addTextlabel("contorlDisplayDateAxis", "A&D: Date-Axis Spacing", infoX, infoY); 
  controlLabel.setColorValue(tc1);
  controlLabel.setGroup(l);
  
  infoY=30+15;
  infoX+=150; 

  controlLabel  = controlP5.addTextlabel("contorlDisplayIndexAxis", "LEFT&RIGHT: Index-Axis Spacing", infoX, infoY); 
  controlLabel.setColorValue(tc1);
  controlLabel.setGroup(l);
  infoY+=15;  
 
  controlLabel  = controlP5.addTextlabel("contorlDisplayvolatility", "UP&DOWN: Degree Of Volatility", infoX, infoY); 
  controlLabel.setColorValue(tc1);
  controlLabel.setGroup(l);
  infoY+=15;  
   controlP5.setAutoDraw(false);
}
void gui() {
  hint(DISABLE_DEPTH_TEST);
  cam.beginHUD();
  fill(0,0,40,200);
  rect(20,80,430,350);
  stroke(255);
  fill(255);
  PFont fText = createFont("Arial", 16);
  textFont(fText);
  text("Press \"1\" for Visualiztion Model 1", 30,90,0 );  
  
  text("Press \"2\" for Visualiztion Model 2", 30,120,0 );  
  
  text("Press \"3\" for Visualiztion Model 3", 30,150,0 );  
    
  text("Press \"t\" for Temperature Data", 30,180,0 );   
 
  text("Press \"h\" for Humidity Data", 30,210,0 );   
  
  text("Press \"r\" for Hovering Effect", 30,240,0 );  

  text("Press \"w\", \"s\" for changing time-axis spacing", 30,270,0 ); 
  
  text("Press \"a\", \"d\" for changing date-axis spacing", 30,300,0 );   
  
  text("Press \"left\", \"right\" for changing index-axis spacing", 30,330,0 );   
  
  text("Press \"up\", \"down\" for changing the degree of volatility", 30,360,0 ); 
  
  text("Press \"m\" to close or open the manual", 30,390,0 ); 
  
  noStroke();
  for(int j = 0; j<24; j++){
  fill(int(60+abs(14-j)*140/12),200,200,180);
  rect(240+j*3, 210-2, 3, 10);}
  
  for(int j = 0; j<24; j++){
  fill(int(abs(14-j)*100/12),200,200,180);
  rect(260+j*3, 180-2, 3, 10);} 

  cam.endHUD();
  hint(ENABLE_DEPTH_TEST);
}

// draw GUI
void drawGUI(){
  hint(DISABLE_DEPTH_TEST);
  cam.beginHUD();
  controlP5.draw();
  cam.endHUD();
  hint(ENABLE_DEPTH_TEST);

}
